%  
% INVALIDATION LOOP FOR AN UNBOUNDED NUMBER OF MONITORS
% COUNTERS ARE PARAMETRIC
% 
% Signature
%
%
% monitor(ID,R,INIT,CURRENT):
%       conta il numero di readers/writers associati alla risorsa ID
% 	ID=identifier, 
% 	INIT,CURRENT=Initial and current values of the counter
%
% In questo esempio i readers devono aspettare che il writer finisca 
% di scrivere. Quando rilascia la regione critica allora i readers possono 
% entrare.


% Initialization 

rule([init],[init(Id,R)],{},i1).

rule([init(Id,R)],[proc(Id,null),init(Id1,R)],{Id1=Id+1},i2).

rule([init(Id,R)],[monitor(Id,idle,R,I,C),init(Id1,R1)],{Id1=Id+1,R1=R+1,I=C},i3).

% Read request 

rule([proc(Id,null),   monitor(M,idle,R,I,C)],
     [proc(Id,read,R), monitor(M,idle,R,I,C1)],{C>=I,C1=C+1},r1).

rule([proc(Id,null),    monitor(M,idle,R,I,C)],
     [proc(Id,waitR,R), monitor(M,idle,R,I,C1)],{C>=I,C1=C+1},r2).

rule([proc(Id,null),    monitor(M,busy,R,I,C)],
     [proc(Id,waitR,R), downgrade(M,busy,R,I,C)],{},r3).

rule([proc(Id,write,R), downgrade(M,busy,R,I,C)],
     [proc(Id,read,R),  monitor(M,idle,R,I,C)],{},r4).


% Nota: monitor locked -> non si puo leggere (bisogna aspettare)

% Write request 

unsafe([unsafe([write(X),read(X)],{})]).

old_unsafe([unsafe([write(X),read(X)],{}),
        unsafe([init_monitor(_),init_monitor(_)],{}),
	unsafe([init_client,init_client],{}),
	unsafe([init,init],{}),
        unsafe([idle(C,_,_),idle(C,_,_)],{}),
	unsafe([locked(L,_,_),locked(L,_,_)],{}),
        unsafe([invalidate(I,_,_),invalidate(I,_,_)],{})
       ]).
       
invariants([
        inv([init_monitor(_),init_monitor(_)],{}),
	inv([init_client,init_client],{}),
	inv([init,init],{}),
        inv([idle(C,_,_),idle(C,_,_)],{}),
	inv([locked(L,_,_),locked(L,_,_)],{}),
        inv([invalidate(I,_,_),invalidate(I,_,_)],{})
       ]).

