%  
% INVALIDATION LOOP FOR AN UNBOUNDED NUMBER OF MONITORS
% COUNTERS ARE PARAMETRIC
% 
% Signature
%
% count(ID,INIT,CURRENT):
%       conta il numero di readers associati alla risorsa ID
% 	ID=identifier, 
% 	INIT,CURRENT=Initial and current values of the counter
%
% In questo esempio i readers devono aspettare che  il writer finisca 
% di scrivere. Quando rilascia la regione critica allora i readers possono 
% entrare.
% Safety: mutua esclusione tra readers & writers
% Unsafe states:  write(ID) | count(ID,I,C): C>I (almeno un reader)
%

rule([init],[demon(X)],{},1).

rule([demon(X)],[count(X,I,C),demon(X1)],{X1>X,I=C},2).

rule([demon(X)],[demon(X),invalid(_)],{},3).

rule([invalid(Y),count(Y,I,C)],[count(Y,I,C1)],{C>=I,C1=C+1},4).

rule([invalid(Y),count(Y,I,C)],[remove(Y,I,C)],{},5).

rule([remove(Y,I,C)],[remove(Y,I,C1),invalid(_)],{C>I,C1=C-1},6).

rule([remove(Y,I,C)],[write(Y)],{I=C},7).

rule([write(Y)],[count(Y,I,C)],{I=C},8).

unsafe([unsafe([write(X),count(X,I,C)],{C>I})]).

old_unsafe([unsafe([write(X),count(X,I,C)],{C>I}),
        unsafe([demon(_),demon(_)],{}),
        unsafe([count(C,_,_),count(C,_,_)],{}),
        unsafe([remove(R,_,_),remove(R,_,_)],{})
       ]).
invariants([]).

old_invariants([
    inv([demon(_),demon(_)],{}),
    inv([init,init],{}),
    inv([count(Z,_,_),count(Z,_,_)],{}),
    inv([remove(Y,_,_),remove(Y,_,_)],{})
]).
