%  
% INVALIDATION LOOP FOR AN UNBOUNDED NUMBER OF MONITORS
% COUNTERS ARE PARAMETRIC
% 
% Signature
%
% count(ID,INIT,CURRENT):
% 
% 	ID=identifier, 
% 	INIT,CURRENT=Initial and current values of the counter
%
%


rule([init],[demon(X)],{},1).

rule([demon(X)],[count(X,I,C),demon(X1)],{X1>X,I=C},2).

rule([demon(X)],[demon(X),invalid(_)],{},3).

rule([invalid(Y),count(Y,I,C)],[count(Y,I,C1)],{C>=I,C1=C+1},4).

%rule([invalid(Y),count(Y,I,C)],[count(Y,I,C1)],{I=C,C1=C+1},5).

rule([invalid(Y),count(Y,I,C)],[remove(Y,I,C)],{},6).

%rule([invalid(Y),count(Y,I,C)],[count(Y,I,C1),write(Y)],{I=C,C1=C+1},7).

%rule([invalid(Y),count(Y,I,C),write(Y)],[remove(Y,I,C)],{},8).

rule([remove(Y,I,C)],[remove(Y,I,C1),invalid(_)],{C>I,C1=C-1},10).

rule([remove(Y,I,C)],[write(Y)],{I=C},11).

%rule([remove(Y,I,C)],[count(Y,I,C1),read(Y)],{I=C,C1=C+1},12).

%rule([count(Y,I,C),write(Y)],[count(Y,I,C1),write(Y)],{C1=C-1,C1>I},13).

%rule([count(Y,I,C),write(Y)],[count(Y,I,C1)],{C1=C-1,C1=I},14).

%rule([count(Y,I,C),read(Y)],[count(Y,I,C1),read(Y)],{C1=C-1,C1>I},15).

%rule([count(Y,I,C),read(Y)],[count(Y,I,C1)],{C1=C-1,C1=I},16).


unsafe([unsafe([read(X),write(X)],{}),
        unsafe([demon(_),demon(_)],{}),
        unsafe([count(C,_,_),count(C,_,_)],{}),
        unsafe([remove(R,_,_),remove(R,_,_)],{})
       ]).

invariants([]).

old_invariants([
    inv([demon(_),demon(_)],{}),
    inv([init,init],{}),
    inv([count(Z,_,_),count(Z,_,_)],{}),
    inv([remove(Y,_,_),remove(Y,_,_)],{})
]).
