rule(
[init],[initP(I,P),demon(X)],
[],
{},
init).

rule(
[initP(I,P)],[initI(I,P),initP(I,P1)],
[],
{P1>P},
initP1).

rule(
[initP(I,P)],[],
[],
{P1>P},
initP2).

rule(
[initI(I,P)],[unlock(I,P),notowner(I,P),nil(I,P),initI(I1,P)],
[],
{I1>I},
initI1).

rule(
[initI(I,P)],[unlock(I,P),owner(I,P),read(I,P)],
[],
{P1>P},
initI2).

rule(
[demon(X)],[tr(I,X),demon(X1)],
[],
{X1>X},
createthreads).

rule(
[tr(I,X)],
[twR(I,X,P)],
[],
{},
readrequest).  

rule(
[twR(I,X,P),unlock(I,P),read(I,P)], 
[ tr(I,X),  unlock(I,P),read(I,P)],
[],
{},
readhitR).  

rule(
[twR(I,X,P),unlock(I,P),write(I,P)],
[ tr(I,X),  unlock(I,P),read(I,P) ],
[],
{},
readhitW). 

rule(
[twR(I,X,P),unlock(I,P),nil(I,P)],
[hRp(I,X,P),  lock(I,P),nil(I,P)],
[],
{},
readmiss).

rule(
[hRp(I,X,P),unlock(J,P),owner(J,P)],
[hRe(I,X,P),  lock(J,P),owner(J,P),serverR(J,P,I)],
[],
{},
handlerR).

rule(
[serverR(J,P,I),  lock(J,P)],
[               unlock(J,P)],
[],
{},
serverR).

rule(
[hRe(I,X,P),  lock(I,P),nil(I,P)],
[ tr(I,X),  unlock(I,P),read(I,P)],
[],
{},
ackR).

rule(
[tr(I,X)],
[twW(I,X,P)],
[],
{},
writerequest).  

rule(
[twW(I,X,P),unlock(I,P),write(I,P)], 
[ tr(I,X),  unlock(I,P),write(I,P)],
[],
{},
writehit). 

rule(
[twW(I,X,P),unlock(I,P),nil(I,P)], 
[hWp(I,X,P),  lock(I,P),nil(I,P)],
[],
{},
writemissN).

rule(
[twW(I,X,P),unlock(I,P),read(I,P)], 
[hWp(I,X,P),  lock(I,P),read(I,P)],
[],
{},
writemissR).


rule(
[hWp(I,X,P),unlock(J,P),owner(J,P)],
[hWi(I,X,P),  lock(J,P),owner(J,P),serverW(J,P)],
[],
{},
handlerW).

rule(
[serverW(J,P),  lock(J,P),read(J,P)],
[             unlock(J,P), nil(J,P)],
[],
{},
serverW).

rule(
[serverW(J,P),  lock(J,P),write(J,P)],
[             unlock(J,P),  nil(J,P)],
[],
{},
serverW).

rule(
[hWi(I,X,P),  lock(J,P),notowner(I,P),nil(I,P)],
[hWp(I,X,P),unlock(J,P),   owner(I,P),write(I,P)],
[reaction([P],read(K,P1),nil(K1,P2),{K1=K,P1=P,P2=P1})],
{},
invalidationN).

rule(
[hWi(I,X,P),  lock(I,P),notowner(I,P), read(I,P)],
[tr(I,X),   unlock(I,P),   owner(I,P),write(I,P)],
[reaction([P],read(K,P1),nil(K1,P2),{K1=K,P1=P,P2=P1})],
{},
invalidationR).

unsafe([         
	 unsafe([write(I,P),read(J,P)],{I>J}),
	 unsafe([write(I1,P1),read(J1,P1)],{J1>I1})
]).


invariants([
 inv([init,init],{}),
 inv([notowner(I1,P1),notowner(I1,P1)],{}),
 inv([read(I2,P2),read(I2,P2)],{}),
 inv([write(I3,P3),write(I3,P3)],{}),
 inv([nil(I4,P4),nil(I4,P4)],{}),
 inv([nil(I5,P5),nil(I5,P5)],{}),
 inv([lock(I6,P6),lock(I6,P6)],{}),
 inv([unlock(I7,P7),unlock(I7,P7)],{}),
 inv([initI(I8,P8),initI(I8,P8)],{}),
 inv([initP(I9,P9),initP(I9,P9)],{}),
 inv([tr(_,X10),tr(_,X10)],{}),
 inv([twW(_,X10),twW(_,X10)],{}),
 inv([twR(_,X11),twR(_,X11)],{}),
 inv([hRp(_,X12),hRp(_,X12)],{}),
 inv([hWp(_,X13),hWp(_,X13)],{}),
 inv([hRe(_,X14),hRe(_,X14)],{}),
 inv([hWe(_,X15),hWe(_,X15)],{}),
 inv([hWi(_,X16),hWi(_,X16)],{})
]).


autoload:-['examples/lihudak.pl'].
