rule(
[tr(I,X)],
[twR(I,X,P)],
[],
{},
readrequest).  

rule(
[ twR(I,X,P), pt(I,P,unlock,OwnF,read) ],  
[ tr(I,X),    pt(I,P,unlock,OwnF,read)],
[],
{},
readhitR).  

rule(
[ twR(I,X,P), pt(I,P,unlock,OwnF,write) ], 
[ tr(I,X),    pt(I,P,unlock,OwnF,write) ],
[],
{},
readhitW). 

rule(
[twR(I,X,P),  pt(I,P,unlock,OwnF,nil)], 
[hRp(I,X,P),  pt(I,P,  lock,OwnF,nil)],
[],
{},
readmiss).

rule(
[hRp(I,X,P),  pt(J,P,unlock,owner,AccR)],
[hRe(I,X,P),  pt(J,P,  lock,owner,AccR), serverR(J,P)],
[],
{},
handlerR).

rule(
[serverR(J,P),pt(J,P,  lock,OwnF,AccR)],
[             pt(J,P,unlock,OwnF,AccR)],
[],
{},
serverR).

rule(
[hRe(I,X,P),  pt(I,P,  lock,OwnF,AccR)],
[ tr(I,X),    pt(I,P,unlock,OwnF,read)],
[],
{},
ackR).

rule(
[tr(I,X)],
[twW(I,X,P)],
[],
{},
writerequest).  

rule(
[twW(I,X,P), pt(I,P,  unlock,OwnF,write)], 
[ tr(I,X),   pt(I,P,  unlock,OwnF,write)],
[],
{},
writehit). 

rule(
[twW(I,X,P), pt(I,P,  unlock,OwnF,nil)], 
[hWp(I,X,P), pt(I,P,    lock,OwnF,nil)],
[],
{},
writemissN).

rule(
[twW(I,X,P), pt(I,P,  unlock,OwnF,read)], 
[hWp(I,X,P), pt(I,P,    lock,OwnF,read)],
[],
{},
writemissR).


rule(
[hWp(I,X,P), pt(J,P,unlock,owner,AccR)],
[hWi(I,X,P), pt(J,P,  lock,owner,AccR),serverW(J,P)],
[],
{},
handlerW).

rule(
[serverW(J,P),pt(J,P,lock,OwnF,AccR)],
[             pt(J,P,unlock,notowner,nil)],
[],
{},
serverW).

rule(
[hWi(I,X,P),  pt(I,P,Sem,OwnF,AccR)],
[tr(I,X),     pt(I,P,unlock,owner,write)],
[reaction([P],pt(K,Q,T,O,A),pt(K,Q,T,O,nil),{Q=P})],
{},
invalidation).

unsafe([         
	 unsafe([pt(I,P,_,_,read),   pt(J,P,_,_,write)],   {I>J}),
	 unsafe([pt(I1,P1,_,_,write),pt(J1,P1,_,_,write) ],{I1>J1}),
	 unsafe([pt(I2,P2,_,_,write),pt(J2,P2,_,_,read) ], {J2>I2}),
	 unsafe([pt(I3,P3,_,owner,_),pt(J3,P3,_,owner,_) ],{I3>J3})	 
]).

invariants([inv([pt(I,P,_,_,_),pt(I,P,_,_,_) ],{})]).

old_invariants([
 inv([init,init],{}),
 inv([pt(I,P,_,_,_),pt(I,P,_,_,_) ],{}),
 inv([initI(I8,P8),initI(I8,P8)],{}),
 inv([initP(I9,P9),initP(I9,P9)],{}),
 inv([tr(_,X7),tr(_,X7)],{}),
 inv([twW(_,X10),twW(_,X10)],{}),
 inv([twR(_,X11),twR(_,X11)],{}),
 inv([hRp(_,X12),hRp(_,X12)],{}),
 inv([hWp(_,X13),hWp(_,X13)],{}),
 inv([hRe(_,X14),hRe(_,X14)],{}),
 inv([hWe(_,X15),hWe(_,X15)],{}),
 inv([hWi(_,X16),hWi(_,X16)],{})
]).


autoload:-['examples/lihudak1.pl'].
