%
% MULTI-SERVER, MULTI-CLIENT, TICKET PROTOCOL
%

% Initialization phase

rule([init], [demon(N)],{},i1).

rule([demon(N)], [think,demon(N)],{},i2).

rule([demon(N)], [demon(N1),count(N,X),turn(N,Y)],{N1=N+1,X=Y},i3).

% Individual behaviour

rule([think,count(N,Y)],[think(N),count(N,Y)],{},b1).

rule([think(N),count(N,Y)],[wait(N,Y),count(N,Y1)],{Y1=Y+1},b1).

rule([wait(N,X),turn(N,X)],[use(N),turn(N,X)],{},b2).

rule([use(N),turn(N,X)], [think,turn(N,X1)],{X1=X+1},b3).


% Unsafe states 

unsafe(
[
unsafe([use(N),use(N)],{}),
unsafe([count(N1,_),count(N1,_)],{}),
unsafe([turn(N2,_),turn(N2,_)],{}),
unsafe([demon(_),demon(_)],{})
]).

invariants([]).
