%  
% PROTOCOL WITH OWNERSHIP
% 
% Signature
%
% proc(ID,ACCESS_RIGHT,OWNER,LIST):
% 
%
%

% Initialization Phase: M clients, counters are created dynamically 

rule([init],    [init(ID)],{},i1).

rule([init(ID)],[proc(ID,null,0,[]),init(ID1)],{ID1>ID},i2).

% Read request 

rule([proc(X,null,0,L),proc(Y,read,1,M)], [proc(X,read,0,L),proc(Y,read,1,[X|M])],{},r1).

rule([proc(X,null,0,L),proc(Y,write,1,M)],[proc(X,read,0,L),proc(Y,read,1,[X|M])],{},r2).

rule([proc(X,null,0,_),proc(Y,_,1,M)],    [proc(X,inv,0,M), proc(Y,null,0,M)],{},r3).

rule([proc(X,inv,I,[Y|L]),proc(Y,_,O,M)], [proc(X,inv,I,L), proc(Y,null,O,M)],{},r4).

rule([proc(X,inv,_,[])],                  [proc(X,write,1,[])],{},r5).



unsafe([
         unsafe([proc(X,_,1,_),proc(Y,_,1,_)],{Y>X})
]).

%invariants([]).    

invariants([
        inv([proc(X,_,_,_),proc(X,_,_,_)],{}),
        inv([init,init],                  {}),
	inv([init(_),init(_)],            {})
       ]).

autoload:-['examples/owner.pl'].
