% Initial States

rule([init], [count(X),turn(Y)],{X=Y},i1).
rule([init], [init,think],{},i2).

% Dynamic Generation

%rule([demon], [think,demon],     {},g1).
%rule([init],  [count(X),turn(Y),demon],    {X=Y},g2).

% Behaviour 

rule([think,count(Y)], [wait(Y1),count(Y2)],{Y1=Y,Y2=Y+1},b1).
rule([wait(X),turn(Y)],[use,turn(Y)],       {X=Y},b2).
rule([use,turn(X)], [think,turn(X1)],       {X1=X+1},b3).

% Crash

rule([think], [],    {},c1).

% Mutual exclusion

unsafe([
  unsafe([use,use],{}),
  unsafe([turn(X),count(Y)],  {X>Y}),
  unsafe([wait(X1),count(Y1)],{X1>=Y1}),
  unsafe([wait(X2),wait(X3)],{X2=X3})
]).

invariants([]).

old_invariants([
 inv([init,init],{}),
 inv([count(_),count(_)],{}),
 inv([turn(_),turn(_)],{})
]).
